SystemOrganization addCategory: #'TP2-SistemaEjemplo-Traits'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Entities'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-UnitTest'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Tests'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-UI'!

Trait named: #TMalo
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

!TMalo commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Trait named: #TTrait1
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

!TTrait1 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Trait named: #TTrait2
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

!TTrait2 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Trait named: #TTrait3
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

!TTrait3 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

TestRunner subclass: #TestArchitectureRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UI'!

!TestArchitectureRunner commentStamp: 'DavidLeonhardt 6/3/2012 15:28' prior: 0!
Interfaz grfica para correr los tests de arquitectura.!

!TestArchitectureRunner methodsFor: 'building' stamp: 'DavidLeonhardt 6/1/2012 23:54'!
build
	"self new build openInWorld"
	
	| window |
	window := (SystemWindow labelled: self label) model: self; extent: self extent.
"	window addMorph: self buildCategories fullFrame: self categoriesFrame.
	window addMorph: self buildClasses fullFrame: self classesFrame.
	"window	addMorph: self buildStatus fullFrame: self statusFrame. "
	"window	addMorph: self buildFailures fullFrame: self failureListFrame. 
	window	addMorph: self buildErrors fullFrame: self errorListFrame. "
	"window	addMorph: self buildButtons fullFrame: self buttonsFrame." "
	^ window
	! !

!TestArchitectureRunner methodsFor: 'accessing-ui' stamp: 'DavidLeonhardt 6/3/2012 16:08'!
buttons
	"botones de la ventana"
	
	^ #(( 'Run Tests' #runAll 'Run all selected tests' #hasRunnable )
		( 'Run Corrections' #runAutomatedCorrection 'Correct' #hasRunnable )
		( 'File out results' #fileOutResults 'File out test results' #hasFailuresOrErrors))! !

!TestArchitectureRunner methodsFor: 'accessing-ui' stamp: 'DavidLeonhardt 6/3/2012 16:08'!
label
	"nombre de la ventana"
	
	^ 'Test Architecture Runner' ! !

!TestArchitectureRunner methodsFor: 'building' stamp: 'DavidLeonhardt 6/3/2012 15:36'!
open
	"Open the window"
	
	classIndex := 1.
	classesSelected := OrderedCollection new.
	classesSelected add: TestArchitecture.
	^ self build openInWorld
! !

!TestArchitectureRunner methodsFor: 'as yet unclassified' stamp: 'LucasMatw 6/4/2012 00:31'!
runAutomatedCorrection
	"corre la correccion de los mtodos que fallaron"
	|test missingAccesors badCategorizedTraits numberOfCorrection |
	test := TestArchitecture  new.
	badCategorizedTraits := (test getBadCategorizedTraits size).
	missingAccesors := (test classesWithoutAccesors size).
	(classesSelected at: classIndex) new perform: #runAutomatedCorrection. 
	
	
	
	AlertDialogWindow 	inform: 'Accesors generated on ', (missingAccesors - (test classesWithoutAccesors size)) printString , ' classes. ' ,   (badCategorizedTraits - (test getBadCategorizedTraits size)) printString , ' bad categorized traits were corrected'. ! !

TestCase subclass: #TestArchitecture
	instanceVariableNames: 'systemOnTest unitTestsCategory unitTestNameStartWith entitiesCategory traitsCategory entitySuperclass minimumMethodComment minimumNamesSize minimumClassComment maxMethodLinesOfCode maxNumberOfMethodsPerClass maximumNamesSize methodMaxArguments doCorrection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Tests'!

!TestArchitecture commentStamp: 'DavidLeonhardt 5/28/2012 19:47' prior: 0!
Testeo de arquitectura.

Comprueba varias cosas....!

!TestArchitecture class methodsFor: 'as yet unclassified' stamp: 'lucas 5/22/2012 18:42'!
setUp 
	| asd|! !

!TestArchitecture methodsFor: 'asserting' stamp: 'lucas 5/24/2012 15:51'!
classInHierachyOf: class subclass: subclass
	"testeo que subclass tenga a class en su jerarquia"

	(subclass superclass == class) ifTrue: [^ true] ifFalse: 
	[(subclass superclass == Object) ifTrue: [^false] ifFalse: [^ (self classInHierachyOf: class subclass: (subclass superclass)) ]]

! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 6/2/2012 11:19'!
classesWithoutAccesors
	"obtener las clases del sistema que les faltan getters/setters"
	
	|classes dictionaryClassAccesor|
	
	dictionaryClassAccesor := Dictionary new.
	classes := self listSystemClasses.
	
	classes do: [:class | (self hasAccesors: class) ifFalse: [
			dictionaryClassAccesor at: class put: (self missingAccesors: class).			
			]].
	
	^dictionaryClassAccesor .! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
doCorrection
	    "getter de la variable de instancia doCorrection"
   
 	   ^doCorrection.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
doCorrection: anObject
	    "setter de la variable de instancia doCorrection"
   
 	   doCorrection:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:40'!
entitiesCategory
	"comment stating purpose of message"

	^entitiesCategory.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
entitiesCategory: anObject
	    "setter de la variable de instancia entitiesCategory"
   
 	   entitiesCategory:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:40'!
entitySuperclass
	"comment stating purpose of message"

	^entitySuperclass.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
entitySuperclass: anObject
	    "setter de la variable de instancia entitySuperclass"
   
 	   entitySuperclass:= anObject! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/2/2012 12:32'!
generateAccesors: class instVars: vars
	"generate the missing accesor"

	vars do: [ :var | (self missAccesor: class accesor: var) ifTrue: [self generateGetter: class instVar: var].
					(self missAccesor: class accesor: (var , ':')) ifTrue: [self generateSetter: class instVar: var].
		]! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/2/2012 12:46'!
generateGetter: class instVar: var
	"genera el getter de var en la clase class"

	(RBAddMethodRefactoring addMethod:
	'' , var, '
	    "getter de la variable de instancia ' , var, '"
   
 	   ^', var, '.' toClass: class inProtocols: 'accessing') execute.! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/2/2012 12:16'!
generateMissingAccesors
	"comment stating purpose of message"

	| targetClasses |
	targetClasses := self classesWithoutAccesors.
	
	targetClasses keys do: [:k | self generateAccesors: k instVars: (targetClasses at: k)]
! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/2/2012 12:45'!
generateSetter: class instVar: var
	"genera el setter de var en la clase class"

	(RBAddMethodRefactoring addMethod:
	'' , var, ': anObject
	    "setter de la variable de instancia ' , var, '"
   
 	   ', var, ':= anObject' toClass: class inProtocols: 'accessing' )execute.! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 6/1/2012 11:28'!
getBadCategorizedTraits
	"obtener los traits que no estan en la categoria correcta"
	| traits categories|

	categories := self listSystemCategories.
	
	traits := categories  inject: #() into: [:classes :cat | classes , (self listTraitsFrom: cat)]. 

	^(traits  select: [:sc | ((sc category ) = traitsCategory) not ]) .! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 5/31/2012 21:15'!
getCompiledMethodName: compiledMethod
	"obtengo el nombre de un metodo compilado "
	^ ((compiledMethod  methodReference asString findTokens:'#') at: 2).! !

!TestArchitecture methodsFor: 'asserting' stamp: 'DavidLeonhardt 5/28/2012 19:09'!
hasAccesors: class
	"Devuelve true si la clase tiene setters y getters."

	| instVariables classMethodsNames |
	instVariables := class instVarNames. 
	
	classMethodsNames := class methodDict keys.
	
	^instVariables allSatisfy: [ 
			:var |
			classMethodsNames includes: var.
			classMethodsNames includes: (var, ':').
		].! !

!TestArchitecture methodsFor: 'initialize-release' stamp: 'DavidLeonhardt 6/3/2012 16:07'!
initialize
	"Inicializador de variables de instancia para las configuraciones de los tests."
	
	super initialize.
	
  	unitTestsCategory := 'TP2-SistemaEjemplo-UnitTest'.
	systemOnTest := 'TP2-SistemaEjemplo'.
	unitTestNameStartWith := 'Test'.
	entitiesCategory := 'TP2-SistemaEjemplo-Entities'.
	traitsCategory := 'TP2-SistemaEjemplo-Traits'.
	entitySuperclass := Entity.
	minimumMethodComment := 5.
	minimumNamesSize := 4.
	minimumClassComment := 4.
	maxMethodLinesOfCode := 25.
	maxNumberOfMethodsPerClass := 15.
	maximumNamesSize := 25.
	methodMaxArguments := 6.
	doCorrection := false.
	
	^self.! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/22/2012 19:20'!
listAllSystemElements
	"comment stating purpose of message"
	| systemCategories |
	systemCategories := self listSystemCategories.
	^ systemCategories inject: #()  into: [:elems :cat | elems , (self listElementsFrom: cat ) ].! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 15:47'!
listAllSystemMethods
	"comment stating purpose of message"

	^ self listSystemClasses inject: #() into: [:mets :class | mets, (class methods)] 
	! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 15:52'!
listAllSystemMethodsNames
	"una lista de todos los metodos del sistema testeado"
	^ self listSystemClasses inject: #() into: [:mets :class | mets, (class methodDict keys)] 

	! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 15:52'!
listClassesFrom: category
	"una lista de todas las clases de la categoria category"
	^ (SystemOrganization classesInCategory: category) select: [:c | c isTrait not].! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 16:05'!
listElementsFrom: category

	"una lista de todos los elementos de la categoria category"
	
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each] ).! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 16:52'!
listMethodsFromCategory: category
	"una lista de los metodos de la categoria category"
	| systemClasses |
	
	systemClasses := self listClassesFrom: category.
	^ systemClasses inject: #()  into: [:mlist :class | mlist , (class methods) ].! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 16:50'!
listSystemCategories
	"una lista de todas las categorias del sistema"
	^ SystemOrganization categoriesMatching: (systemOnTest , '*').! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 6/2/2012 11:40'!
listSystemClasses
	"listar todas las clases del sistema"

	^ self listAllSystemElements select: [:elem | elem isTrait not].
! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 6/2/2012 11:38'!
listTraitsFrom: category
	"una lista de todos los traits de la categoria category"
	^( self listElementsFrom: category) select: [ :elem | elem isTrait ].! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/26/2012 20:06'!
maxMethodLinesOfCode
	"comment stating purpose of message"
	^ maxMethodLinesOfCode.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
maxMethodLinesOfCode: anObject
	    "setter de la variable de instancia maxMethodLinesOfCode"
   
 	   maxMethodLinesOfCode:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/26/2012 20:25'!
maxNumberOfMethodsPerClass
	"comment stating purpose of message"

	^maxNumberOfMethodsPerClass.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
maxNumberOfMethodsPerClass: anObject
	    "setter de la variable de instancia maxNumberOfMethodsPerClass"
   
 	   maxNumberOfMethodsPerClass:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/28/2012 15:38'!
maximumNamesSize
	"getter"

	^ maximumNamesSize.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
maximumNamesSize: anObject
	    "setter de la variable de instancia maximumNamesSize"
   
 	   maximumNamesSize:= anObject! !

!TestArchitecture methodsFor: 'asserting' stamp: 'lucas 5/26/2012 20:07'!
methodDontExceedLinesOfCode: aMethod
	"returna true si el metodo aMethod tiene hasta 20 lineas de cdigo.
		Cuento una linea de cdigo con cada mensaje en cascada, o sea, cuando encuentro un ';'
		o cuando finaliza un mensaje con '.'"
	
	^ aMethod linesOfCode < maxMethodLinesOfCode .! !

!TestArchitecture methodsFor: 'asserting' stamp: 'LucasMatw 6/1/2012 11:27'!
methodIsDocumented: method withNumOfChars: requestedCommentSize
	"returna true si el metodo method tiene un comentario con requestedCommentSize caracteres o mas"
	| possibleComment  source  sourceTail|

	source := method getSource.
	possibleComment := method comment.
	sourceTail := (self methodSourceWithoutFirstLine: method) onlyLetters.

	(possibleComment notNil) ifTrue: [
		^(((sourceTail indexOfSubCollection: (possibleComment onlyLetters )) = 1) & (possibleComment size >= requestedCommentSize)).] 
		
						ifFalse: [^false].
	


	! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/28/2012 16:54'!
methodMaxArguments
	"getter"

	^ methodMaxArguments.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
methodMaxArguments: anObject
	    "setter de la variable de instancia methodMaxArguments"
   
 	   methodMaxArguments:= anObject! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 5/31/2012 22:28'!
methodSourceWithoutFirstLine: method
	"comment stating purpose of message"

	| source result separatedSource|

	source := method getSource.
	separatedSource := ((source findTokens: (Character cr)) copyWithoutIndex: 1).
	
	result := separatedSource inject: '' into: [ :res :str | res , str].  
	^ result.

	! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/26/2012 19:57'!
minimumClassComment 
	"getter"
	^ minimumClassComment.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
minimumClassComment: anObject
	    "setter de la variable de instancia minimumClassComment"
   
 	   minimumClassComment:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:43'!
minimumMethodComment
	"comment stating purpose of message"

	^minimumMethodComment.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
minimumMethodComment: anObject
	    "setter de la variable de instancia minimumMethodComment"
   
 	   minimumMethodComment:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:40'!
minimumNamesSize
	"comment stating purpose of message"

	^minimumNamesSize.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
minimumNamesSize: anObject
	    "setter de la variable de instancia minimumNamesSize"
   
 	   minimumNamesSize:= anObject! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 6/2/2012 12:30'!
missAccesor: class accesor: methodName
	"retorna true si a la clase class le falta el getter de var"

	| instVariables classMethodsNames |
	instVariables := class instVarNames. 
	(instVariables includes: (methodName onlyLetters) ) ifFalse: [ self error: 'class ', (class asString ), ' does not have the instance variable ', methodName].
	
	classMethodsNames := class methodDict keys.
	
	^(classMethodsNames includes: methodName) not.

! !

!TestArchitecture methodsFor: 'extensions' stamp: 'LucasMatw 6/2/2012 11:08'!
missingAccesors: class
	"Devuelve una lista con las variables de instancia a las que les falta el getter, setter o ambos"

	| instVariables classMethodsNames |
	instVariables := class instVarNames. 
	
	classMethodsNames := class methodDict keys.
	
	^instVariables select: [ 
			:var |
			(classMethodsNames includes: var) not |
			(classMethodsNames includes: (var, ':')) not.
		].! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/24/2012 16:49'!
nameOfClass: testName
	"de un test, retorna solo el nombre de la clase (basandose en el nombre del test)"
	^ testName copyFrom: (unitTestNameStartWith size +1) to: (testName size) ! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/1/2012 12:05'!
recategorizeElements: elements on: categoryName
	"recategoriza cada elemento de elements con categoryName "

	elements do: [:elem | elem category: categoryName ].! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/1/2012 12:02'!
recategorizeTraits
	"comment stating purpose of message"

	| badTraits |
	badTraits := self getBadCategorizedTraits.
	
	self recategorizeElements: badTraits  on: (self traitsCategory).  ! !

!TestArchitecture methodsFor: 'refactor-correction' stamp: 'LucasMatw 6/2/2012 11:43'!
runAutomatedCorrection
	"corrije algunos de los errores automaticamente"

	self recategorizeTraits.
	self generateMissingAccesors.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'DavidLeonhardt 6/2/2012 13:50'!
systemOnTest
	"getter de la variable systemOnTest"

	^systemOnTest.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'DavidLeonhardt 6/3/2012 15:46'!
systemOnTest: anObject
	    "setter de la variable de instancia systemOnTest"
   
 	   systemOnTest:= anObject! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/24/2012 15:49'!
testCaseCorrectlyNamed
	"testeo que los test unitarios esten nombrados correctamente"
	| utestNames classNames|
	
	utestNames := ((self listClassesFrom: unitTestsCategory ) select: [ :c | c superclass == TestCase ])collect: [:ut | ut name] .
	
	classNames := (self listClassesFrom: systemOnTest) collect: [:c | c name] .
	
	utestNames do: [ :utn | self assert: (classNames includes: (self nameOfClass: utn)) 
		description:  'all unit test names must match "' , unitTestNameStartWith , ' + <class name>"'].
	
	
! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/26/2012 20:25'!
testClassesDontExceedMaxNumberOfMethods
	"compruebo que todas las clases no tengan mas metodos de los permitidos"
	| classes |

	classes  := self listClassesFrom: self systemOnTest .
	
	classes do: [ :c | self assert: (c methods size <= maxNumberOfMethodsPerClass ) description: 'the class ', (c name) , ' exceed the maximum number of methods allowed'].
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'LucasMatw 6/2/2012 11:25'!
testClassesHaveAccesors
	"testeo que todas las clases tengan getters y setters "
	| classesWithoutAccesors  |
	classesWithoutAccesors := self classesWithoutAccesors.
	
	self assert: ( classesWithoutAccesors isEmpty ) description: 'classes ',  (classesWithoutAccesors asString ) , ' must implement accesors'.
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'DavidLeonhardt 5/28/2012 19:45'!
testClassesHaveDocumentation
	"compruebo que todas las clases tengan una documentacion (texto mayor a 5 caracteres)"
	| classes |

	classes  := self listAllSystemElements.
	
	classes do: [ :c | self assert: ((c comment size) > minimumClassComment  & ((c comment findString: 'is xxxxxxxxx.') = 0) ) description: 'the class must have a comment of', (minimumClassComment printString),   ' characters or more'].
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'DavidLeonhardt 5/28/2012 19:18'!
testCorrectlyNamedSystemElements
	"testeo que todas las clases/traits/etc tengan un nombre con un minimo de caracteres"
	| systemElements |
	systemElements := self listAllSystemElements. 
	systemElements do:[ :elem | self assert: (elem name size >= (self minimumNamesSize) ) description: 'the name of element: ', elem name, ' must have : ', (self minimumNamesSize printString)  , ' characters or more'.
		self assert: (elem name size <= (self maximumNamesSize) ) description: 'the name of element: ', elem name, ' must have : ', (self maximumNamesSize printString)  , ' characters or less'].! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/24/2012 15:50'!
testEachClassWithUnitTest
	"testeo que cada clase tenga un test unitario"
	| utestNames classNames|
	
	utestNames := (self listClassesFrom: unitTestsCategory ) collect: [:ut | ut name] .
	
	classNames := (self listClassesFrom: systemOnTest ) collect: [:c | c name] .
 
	classNames do: [ :cn | self assert: (utestNames includes: (unitTestNameStartWith , cn)) description: 'each class need a test case']! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/24/2012 15:50'!
testEntitiesOnPackage
	"teste que las entidades esten en la categoria correspondiente"
	| classes |
	
	classes := self listClassesFrom:   entitiesCategory .
	
	
	classes do: [:each | self assert: (self classInHierachyOf: entitySuperclass  subclass: each)] 
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/26/2012 20:10'!
testMethodsDontExceedMaxLinesOfCode
	"testeo que todos los metodos no sobrepasen el maximo de  lineas de cdigo"
	| systemMethods |
	
	systemMethods := self listAllSystemMethods.
	
	
	systemMethods do: [:met | self assert: ( self methodDontExceedLinesOfCode: met ) description: 'The method: ', (self getCompiledMethodName: met), 'has more than ' , (maxMethodLinesOfCode printString) , ' lines code.'].

! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/28/2012 16:54'!
testMethodsDontExceedMaxNumberOfArgs
	"testeo que todos los metodos no sobrepasen el maximo de parametros"
	| systemMethods |
	
	systemMethods := self listAllSystemMethods.
	
	
	systemMethods do: [:met | self assert: ( met numArgs <= methodMaxArguments) description: 'the method ', (met name) , ' exceed the max number of arguments per method'.]
! !

!TestArchitecture methodsFor: 'testing' stamp: 'DavidLeonhardt 5/25/2012 17:08'!
testMethodsHaveDocumentation
	"testeo que todos los metodos tengan un comentario"
	| systemMethods |
	
	systemMethods := self listAllSystemMethods.
	
	
	systemMethods do: [:met | self assert: (self methodIsDocumented: met withNumOfChars: minimumMethodComment) description: 'the method: ', (self getCompiledMethodName: met), 'does not have a correct description'].

! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/24/2012 15:51'!
testTraitsCorrectlyNamed
	"testeo que los traits esten nombrados correctamente"
	| traitNames traits|
	
	traits := self listTraitsFrom:  traitsCategory .
	traitNames := traits collect: [:t | t name].
	
	traitNames  do: [:tn |  self assert: $T equals: (tn first). 
		self assert: (tn size > minimumNamesSize ) description: 'trait name must have ' , (minimumNamesSize printString) , ' letters or more'.
		self assert: (tn second isUppercase) description: 'second letter of the trait name must be uppercase'.
		self assert: (tn third isLowercase ) description:  'third letter of the trait name must be lowercase']
	
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'LucasMatw 6/1/2012 12:05'!
testTraitsOnCorrectCategory
	"testeo que los traits esten en la categoria que corresponda"
	|  badTraits|

	badTraits := self getBadCategorizedTraits.
	
	self assert: (badTraits isEmpty) description: ('traits: ', (badTraits printString) , ' are not on the correct category')! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:40'!
traitsCategory
	"comment stating purpose of message"

	^traitsCategory.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
traitsCategory: anObject
	    "setter de la variable de instancia traitsCategory"
   
 	   traitsCategory:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:40'!
unitTestNameStartWith
	"comment stating purpose of message"

	^unitTestNameStartWith.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
unitTestNameStartWith: anObject
	    "setter de la variable de instancia unitTestNameStartWith"
   
 	   unitTestNameStartWith:= anObject! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/24/2012 15:39'!
unitTestsCategory
	"comment stating purpose of message"

	^unitTestsCategory.! !

!TestArchitecture methodsFor: 'accessing' stamp: 'LucasMatw 6/2/2012 12:46'!
unitTestsCategory: anObject
	    "setter de la variable de instancia unitTestsCategory"
   
 	   unitTestsCategory:= anObject! !

TestCase subclass: #TestClase1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

!TestClase1 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

TestCase subclass: #TestClase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

!TestClase2 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

TestCase subclass: #TestClase3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

!TestClase3 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

TestCase subclass: #TestEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

!TestEntity commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Object subclass: #Clase1
	instanceVariableNames: 'varx vary varz'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

!Clase1 commentStamp: 'DavidLeonhardt 5/28/2012 19:44' prior: 0!
Comment example for Clase1.!

!Clase1 methodsFor: 'printing' stamp: 'LucasMatw 6/1/2012 13:51'!
printOn: aStream
	"Append a sequence of characters to aStream that identify the receiver."

	super printOn: aStream! !

!Clase1 methodsFor: 'accessing' stamp: 'LucasMatw 6/4/2012 00:28'!
varx
	    "getter de la variable de instancia varx"
   
 	   ^varx.! !

!Clase1 methodsFor: 'accessing' stamp: 'LucasMatw 6/4/2012 00:28'!
varx: anObject
	    "setter de la variable de instancia varx"
   
 	   varx:= anObject! !

!Clase1 methodsFor: 'accessing' stamp: 'LucasMatw 6/4/2012 00:28'!
vary
	    "getter de la variable de instancia vary"
   
 	   ^vary.! !

!Clase1 methodsFor: 'accessing' stamp: 'LucasMatw 6/4/2012 00:28'!
vary: anObject
	    "setter de la variable de instancia vary"
   
 	   vary:= anObject! !

!Clase1 methodsFor: 'varz' stamp: 'LucasMatw 6/2/2012 12:43'!
varz
	    "getter de la variable de instancia varz"
   
 	   ^varz.! !

!Clase1 methodsFor: 'varz:' stamp: 'LucasMatw 6/2/2012 12:43'!
varz: anObject
	    "setter de la variable de instancia varz"
   
 	   varz:= anObject! !

Object subclass: #Clase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

!Clase2 commentStamp: 'DavidLeonhardt 5/25/2012 13:26' prior: 0!
Comment example for Clase2.!

!Clase2 methodsFor: 'as yet unclassified' stamp: 'Lucas 5/28/2012 20:23'!
methodX


	"tengo un comentario"
	| asdsds |
	
	asdsds := 50.
	"un comentario random"
     ^True.

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/19/2012 14:54'!
methodY
	"a description of the method"

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/19/2012 21:07'!
methodZ
	"un comentario copado"
	| hola|
	hola := 3.
	"tengo un comentario aca"
	'asdsd'.
	^ hola*2

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/24/2012 16:35'!
methodZ: aaaa to: bbbbbb
	"un comentario copado"
	| hola|
	hola := 3.
	"tengo un comentario aca"
	'asdsd'.
	^ hola*2

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/28/2012 16:55'!
methodZ: aaaa to: bbbbbb and: cccc and: dddd and: eeee and: zzzzz
	"un comentario copado"
	| hola|
	hola := 3.
	"tengo un comentario aca"
	'asdsd'.
	^ hola*2

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/28/2012 16:55'!
methodZ: aaaa to: bbbbbb and: cccc and: dddd and: eeee and: zzzzz and: xxxxx
	"un comentario copado"
	| hola|
	hola := 3.
	"tengo un comentario aca"
	'asdsd'.
	^ hola*2

	! !

Object subclass: #Clase3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

!Clase3 commentStamp: 'DavidLeonhardt 5/25/2012 16:46' prior: 0!
Comment example for Clase3.!

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 20:41'!
m1
	"Comentario de mtodo."
	
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	Transcript show: 'hola'; cr.
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m10
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m11
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m12
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m13
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m14
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m15
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m2
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m3
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m4
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m5
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m6
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m7
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m8
	"Comentario de mtodo."
	
	^self.! !

!Clase3 methodsFor: 'as yet unclassified' stamp: 'DavidLeonhardt 5/25/2012 16:50'!
m9
	"Comentario de mtodo."
	
	^self.! !

Object subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

!Entity commentStamp: 'DavidLeonhardt 5/25/2012 13:26' prior: 0!
Comment example for Entity.!

Entity subclass: #Entity1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

!Entity1 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Entity subclass: #Entity2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

!Entity2 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Entity2 subclass: #Entity3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

!Entity3 commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!

Entity3 subclass: #EntityBuena
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

!EntityBuena commentStamp: 'DavidLeonhardt 5/28/2012 19:46' prior: 0!
Ejemplo de comentario!
